#-*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, os, sys, xbmcaddon
import shutil
import urllib
import re

dialog = xbmcgui.Dialog()    
thumbdir = xbmc.translatePath('special://thumbnails')
cachePath = os.path.join(xbmc.translatePath('special://home'), 'cache')
tempPath = xbmc.translatePath('special://temp')

ADDON=xbmcaddon.Addon(id='plugin.program.dokitvclean')
rootDir = ADDON.getAddonInfo('path')
if rootDir[-1] == ';':
    rootDir = rootDir[0:-1]
rootDir = xbmc.translatePath(rootDir)
dokifanart = xbmc.translatePath(os.path.join(rootDir, 'fanart.jpg'))
dokiicon = xbmc.translatePath(os.path.join(rootDir, 'icon.png'))


    
def index():
    addDir('Volledige Kodi reset','',5,dokiicon,dokifanart,'', folder=False)

            
def cleanStart():
    yes_pressed = dialog.yesno("[COLOR palegreen][B]Schone install[/COLOR][/B]", '[COLOR palegreen]Hiermee verwijderd je alles in Kodi[/COLOR]', '[COLOR snow]Weet u zeker dat u hiermee door wilt gaan?[/COLOR]', '', yeslabel='JA',nolabel='NEE')
    if yes_pressed:
        excludes = ['plugin.program.dokitv',]
        xbmcdir = xbmc.translatePath('special://home/')
        xbmcdir=os.path.abspath(xbmcdir)
        for root, dirs, files in os.walk(xbmcdir, topdown=True):
            dirs[:] = [d for d in dirs if d not in excludes]
            for name in files:
                try: os.remove(os.path.join(root, name))
                except: pass
            for name in dirs:
                if name not in ["addons", "addon_data", "userdata"]:
                    try: shutil.rmtree(os.path.join(root, name), ignore_errors=True, onerror=None)
                    except: pass
        killxbmc()

def killxbmc():
    myplatform = platform()
    try: os._exit(1)
    except: pass
    print "Platform: " + str(myplatform)
    if myplatform == 'osx': # OSX
        print "############   try osx force close  #################"
        try: os.system('killall -9 XBMC')
        except: pass
        try: os.system('killall -9 Kodi')
        except: pass
        dialog.ok("[COLOR=red][B]WAARSCHUWING  !!![/COLOR][/B]", "Als je dit bericht ziet is het geforceerd sluiten", "mislukt. Sluit kodi geforceerd [COLOR=palegreen]NIET VIA[/COLOR] het menu afsluiten.",'')
    elif myplatform == 'linux': #Linux
        print "############   try linux force close  #################"
        try: os.system('killall XBMC')
        except: pass
        try: os.system('killall Kodi')
        except: pass
        try: os.system('killall -9 xbmc.bin')
        except: pass
        try: os.system('killall -9 kodi.bin')
        except: pass
        dialog.ok("[COLOR=red][B]WAARSCHUWING  !!![/COLOR][/B]", "Als je dit bericht ziet is het geforceerd sluiten", "mislukt. Sluit kodi geforceerd [COLOR=palegreen]NIET VIA[/COLOR] het menu afsluiten.",'')
    elif myplatform == 'android': # Android  
        print "############   try android force close  #################"
        try: os.system('adb shell am force-stop org.xbmc.kodi')
        except: pass
        try: os.system('adb shell am force-stop org.kodi')
        except: pass
        try: os.system('adb shell am force-stop org.xbmc.cemc')
        except: pass
        try: os.system('adb shell am force-stop org.xbmc.cemc_pro')
        except: pass
        try: os.system('adb shell am force-stop com.semperpax.spmc16') 
        except: pass
        try: os.system('adb shell am force-stop org.lodi.mobi') 
        except: pass
        try: os.system('adb shell am force-stop com.perfectzoneproductions.jesusboxmedia')
        except: pass
        try: os.system('adb shell am force-stop org.xbmc.xbmc') 
        except: pass
        try: os.system('adb shell am force-stop org.xbmc')
        except: pass
        try: os.system('adb shell kill org.xbmc.kodi')
        except: pass
        try: os.system('adb shell kill org.kodi')
        except: pass
        try: os.system('adb shell kill org.xbmc.xbmc')
        except: pass
        try: os.system('adb shell kill org.xbmc')
        except: pass
        try: os.system('adb shell kill com.semperpax.spmc16')
        except: pass
        try: os.system('adb shell kill com.semperpax')
        except: pass
        try: os.system('adb shell kill com.perfectzoneproductions.jesusboxmedia')
        except: pass
        try: os.system('adb shell kill org.xbmc.cemc')
        except: pass
        try: os.system('adb shell kill org.xbmc.cemc_pro')
        except: pass
        try: os.system('adb shell kill org.lodi.mobi')
        except: pass
        try: os.system('adb shell kill com.semperpax')
        except: pass
        try: os.system('Process.killProcess(android.os.Process.org.xbmc.kodi());')
        except: pass
        try: os.system('Process.killProcess(android.os.Process.org.kodi());')
        except: pass
        try: os.system('Process.killProcess(android.os.Process.org.xbmc.xbmc());')
        except: pass
        try: os.system('Process.killProcess(android.os.Process.org.xbmc());')
        except: pass
        dialog.ok("[COLOR=red][B]WAARSCHUWING  !!![/COLOR][/B]", "We hebben gedetecteerd dat er gebruik gemaakt word van Android, U ", "[COLOR=yellow][B]MOET[/COLOR][/B] kodi geforceerd sluiten. [COLOR=palegreen]NIET VIA[/COLOR] het menu afsluiten.","Of proces beëindigen met taakbeheer (Als je het niet zeker weet haal de stroom van de speler af).")
    elif myplatform == 'windows': # Windows
        print "############   try windows force close  #################"
        try:
            os.system('@ECHO off')
            os.system('tskill XBMC.exe')
        except: pass
        try:
            os.system('@ECHO off')
            os.system('tskill Kodi.exe')
        except: pass
        try:
            os.system('@ECHO off')
            os.system('tskill SMC.exe')
        except: pass
        try:
            os.system('@ECHO off')
            os.system('TASKKILL /im Kodi.exe /f')
        except: pass
        try:
            os.system('@ECHO off')
            os.system('TASKKILL /im SMC.exe /f')
        except: pass
        try:
            os.system('@ECHO off')
            os.system('TASKKILL /im XBMC.exe /f')
        except: pass
        dialog.ok("[COLOR=red][B]WAARSCHUWING  !!![/COLOR][/B]", "Als je dit bericht ziet is het geforceerd sluiten", "mislukt. Sluit kodi geforceerd [COLOR=palegreen]NIET VIA[/COLOR] het menu afsluiten.","gebruik taak beheer en geen ALT F4")
    else: #ATV
        print "############   try atv force close  #################"
        try: os.system('killall AppleTV')
        except: pass
        print "############   try raspbmc force close  #################" #OSMC / Raspbmc
        try: os.system('sudo initctl stop kodi')
        except: pass
        try: os.system('sudo initctl stop xbmc')
        except: pass
        dialog.ok("[COLOR=red][B]WAARSCHUWING  !!![/COLOR][/B]", "Als je dit bericht ziet is het geforceerd sluiten", "mislukt. Sluit kodi geforceerd [COLOR=palegreen]NIET VIA[/COLOR] het menu afsluiten.","het apparaat kon niet worden gedetecteerd dus verwijder de stroom kabel en start opnieuw.")

def platform():
    if xbmc.getCondVisibility('system.platform.android'): return 'android'
    elif xbmc.getCondVisibility('system.platform.linux'): return 'linux'
    elif xbmc.getCondVisibility('system.platform.windows'): return 'windows'
    elif xbmc.getCondVisibility('system.platform.osx'): return 'osx'
    elif xbmc.getCondVisibility('system.platform.atv2'): return 'atv2'
    elif xbmc.getCondVisibility('system.platform.ios'): return 'ios'


def addDir(name,url,mode,iconimage,fanart,description,folder=True):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=folder)
        return ok
        
       
        
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param
        
                      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try: url=urllib.unquote_plus(params["url"])
except: pass

try: name=urllib.unquote_plus(params["name"])
except: pass

try: iconimage=urllib.unquote_plus(params["iconimage"])
except: pass

try: mode=int(params["mode"])
except: pass


        
        
if mode==None: index()
elif mode==5: cleanStart()

skin = xbmc.getSkinDir().lower()
viewmode = 55 if 'estuary' in skin else 50

xbmcplugin.setContent(int(sys.argv[1]), 'files')
xbmc.executebuiltin("Container.SetViewMode(%s)" % viewmode)
xbmcplugin.endOfDirectory(int(sys.argv[1]))